import { openBlock as s, createElementBlock as o, createElementVNode as l, toDisplayString as u, renderSlot as _, ref as x, computed as m, normalizeClass as w, unref as f, createVNode as z, withCtx as h, useSlots as N, resolveComponent as C, Fragment as S, renderList as V, createBlock as y, createTextVNode as B, createCommentVNode as v, inject as T, withDirectives as L, isRef as q, vModelDynamic as I, provide as F, vModelSelect as E, vModelText as j, watch as Z, normalizeStyle as G, onMounted as P, withModifiers as A, vModelCheckbox as H, withKeys as X } from "vue";
const J = { class: "cf-action-card" }, Q = { class: "cf-action-card__body" }, W = { class: "cf-action-card__title" }, Y = { class: "cf-action-card__body__slot" }, ee = { class: "cf-action-card__action" }, xs = {
  __name: "ActionCard",
  props: {
    title: String
  },
  setup(n) {
    const t = n;
    return (e, a) => (s(), o("div", J, [
      l("div", Q, [
        l("div", W, u(t.title), 1),
        l("div", Y, [
          _(e.$slots, "body")
        ])
      ]),
      l("div", ee, [
        _(e.$slots, "action")
      ])
    ]));
  }
};
const K = (n, t) => {
  const e = n.__vccOpts || n;
  for (const [a, d] of t)
    e[a] = d;
  return e;
}, te = {}, se = { class: "cf-app-bar" };
function le(n, t) {
  return s(), o("header", se, [
    l("div", null, [
      _(n.$slots, "left")
    ]),
    l("div", null, [
      _(n.$slots, "right")
    ])
  ]);
}
const oe = /* @__PURE__ */ K(te, [["render", le]]);
const ae = { class: "cf-dropdown-body" }, ne = {
  __name: "Dropdown",
  setup(n) {
    const t = x(!1), e = m(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (a, d) => (s(), o("div", {
      class: w(f(e))
    }, [
      l("div", {
        class: "cf-dropdown-toggle",
        onClick: d[0] || (d[0] = (i) => t.value = !t.value)
      }, [
        _(a.$slots, "toggle")
      ]),
      l("div", ae, [
        _(a.$slots, "body")
      ]),
      l("div", {
        class: "cf-dropdown-backdrop",
        onClick: d[1] || (d[1] = (i) => t.value = !1)
      })
    ], 2));
  }
};
const ie = {
  key: 0,
  class: "cf-app-bar-link"
}, de = { class: "cf-app-bar-link__label" }, re = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), ue = {
  key: 1,
  class: "cf-app-bar-link"
}, ce = { class: "cf-app-bar-link__label" }, Ss = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(n) {
    return (t, e) => n.dropdown ? (s(), o("div", ie, [
      z(ne, null, {
        toggle: h(() => [
          l("div", de, [
            _(t.$slots, "default"),
            re
          ])
        ]),
        body: h(() => [
          _(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (s(), o("button", ue, [
      l("div", ce, [
        _(t.$slots, "default")
      ])
    ]));
  }
};
const _e = {
  key: 0,
  class: "cf-app-view-breadcrumbs"
}, pe = { key: 1 }, fe = {
  key: 1,
  class: "cf-app-view-header"
}, ve = { key: 0 }, be = {
  key: 1,
  class: "cf-app-view-header__description"
}, me = {
  key: 2,
  class: "cf-app-view-header__actions"
}, Vs = {
  __name: "AppView",
  props: {
    title: String,
    description: String,
    breadcrumbs: Array,
    wide: Boolean
  },
  setup(n) {
    const t = n, e = N(), a = m(() => ({
      "cf-app-view": !0,
      "cf-app-view--wide": t.wide
    }));
    return (d, i) => {
      const c = C("router-link");
      return s(), o("div", {
        class: w(f(a))
      }, [
        t.breadcrumbs ? (s(), o("ol", _e, [
          (s(!0), o(S, null, V(t.breadcrumbs, (p) => (s(), o("li", {
            key: p.name
          }, [
            p.path ? (s(), y(c, {
              key: 0,
              to: p.path
            }, {
              default: h(() => [
                B(u(p.name), 1)
              ]),
              _: 2
            }, 1032, ["to"])) : (s(), o("span", pe, u(p.name), 1))
          ]))), 128))
        ])) : v("", !0),
        t.title || t.description || f(e).actions ? (s(), o("div", fe, [
          t.title ? (s(), o("h1", ve, u(t.title), 1)) : v("", !0),
          t.description ? (s(), o("div", be, u(t.description), 1)) : v("", !0),
          f(e).actions ? (s(), o("div", me, [
            _(d.$slots, "actions")
          ])) : v("", !0)
        ])) : v("", !0),
        _(d.$slots, "default")
      ], 2);
    };
  }
};
const Bs = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(n) {
    const t = n, e = m(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (a, d) => (s(), o("div", {
      class: w(f(e))
    }, [
      _(a.$slots, "default")
    ], 2));
  }
}, U = {
  to: {
    type: String,
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: Boolean,
  wide: Boolean,
  color: {
    type: String,
    default: null
  },
  loading: Boolean,
  disabled: Boolean
};
const he = ["type", "disabled"], Cs = {
  __name: "FilledButton",
  props: U,
  setup(n) {
    const t = n, e = m(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (a, d) => {
      const i = C("router-link");
      return a.to ? (s(), y(i, {
        key: 0,
        class: w(f(e)),
        to: a.to,
        inert: t.disabled
      }, {
        default: h(() => [
          _(a.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (s(), o("button", {
        key: 1,
        class: w(f(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        _(a.$slots, "default")
      ], 10, he));
    };
  }
};
const ge = ["type", "disabled"], ye = {
  __name: "OutlinedButton",
  props: U,
  setup(n) {
    const t = n, e = m(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (a, d) => {
      const i = C("router-link");
      return a.to ? (s(), y(i, {
        key: 0,
        class: w(f(e)),
        to: a.to,
        inert: t.disabled
      }, {
        default: h(() => [
          _(a.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (s(), o("button", {
        key: 1,
        class: w(f(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        _(a.$slots, "default")
      ], 10, ge));
    };
  }
};
const $e = ["disabled"], qs = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(n) {
    const t = n;
    return (e, a) => {
      const d = C("router-link");
      return n.to ? (s(), y(d, {
        key: 0,
        class: "cf-text-button",
        to: n.to,
        inert: t.disabled
      }, {
        default: h(() => [
          _(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (s(), o("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        _(e.$slots, "default")
      ], 8, $e));
    };
  }
};
const ke = { class: "cf-choice" }, we = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], xe = ["for"], Se = { key: 0 }, Ve = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Array],
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: String,
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = Math.random(), d = {
      name: T("choice-list-name", null),
      required: T("choice-list-required", null)
    }, i = m({
      get() {
        return e.modelValue;
      },
      set(c) {
        t("update:modelValue", c);
      }
    });
    return (c, p) => (s(), o("div", ke, [
      L(l("input", {
        "onUpdate:modelValue": p[0] || (p[0] = (k) => q(i) ? i.value = k : null),
        type: e.type,
        id: f(a),
        name: d.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: d.required,
        disabled: e.disabled
      }, null, 8, we), [
        [I, f(i)]
      ]),
      l("label", { for: f(a) }, u(e.label || e.value), 9, xe),
      e.helper ? (s(), o("small", Se, u(e.helper), 1)) : v("", !0)
    ]));
  }
};
const Be = {
  key: 0,
  class: "cf-choice-list__label"
}, Ds = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = m(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), d = m({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return F("choice-list-name", Math.random()), F("choice-list-required", e.required), (i, c) => (s(), o("div", {
      class: w(f(a))
    }, [
      e.label ? (s(), o("div", Be, u(e.label), 1)) : v("", !0),
      (s(!0), o(S, null, V(n.choices, (p) => (s(), y(Ve, {
        key: p.value || p,
        type: e.multiple ? "checkbox" : "radio",
        label: p.label || p.value || p,
        helper: p.helper,
        value: p.value || p,
        disabled: e.disabled,
        modelValue: f(d),
        "onUpdate:modelValue": c[0] || (c[0] = (k) => q(d) ? d.value = k : null)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128)),
      _(i.$slots, "default")
    ], 2));
  }
};
const Ce = { class: "cf-field" }, qe = ["required", "disabled"], De = {
  key: 0,
  value: null
}, Le = ["value"], ze = ["required", "disabled"], Ae = ["type", "placeholder", "list", "required", "disabled"], Te = {
  key: 3,
  class: "cf-field__prefix"
}, Fe = {
  key: 4,
  class: "cf-field__suffix"
}, Me = { key: 5 }, Ne = { key: 6 }, Ie = /* @__PURE__ */ l("div", { class: "cf-field__outline" }, null, -1), O = {
  __name: "Field",
  props: {
    modelValue: [Number, String],
    type: String,
    label: String,
    placeholder: String,
    prefix: String,
    suffix: String,
    options: Array,
    list: String,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = m({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return (d, i) => (s(), o("div", Ce, [
      e.type === "select" ? L((s(), o("select", {
        key: 0,
        class: "cf-field__input",
        "onUpdate:modelValue": i[0] || (i[0] = (c) => q(a) ? a.value = c : null),
        required: e.required,
        disabled: e.disabled
      }, [
        !e.required && e.options.length ? (s(), o("option", De)) : v("", !0),
        (s(!0), o(S, null, V(e.options, (c) => (s(), o("option", {
          key: c.value || c,
          value: c.value || c
        }, u(c.label || c), 9, Le))), 128))
      ], 8, qe)), [
        [E, f(a)]
      ]) : e.type === "textarea" ? L((s(), o("textarea", {
        key: 1,
        class: "cf-field__input",
        "onUpdate:modelValue": i[1] || (i[1] = (c) => q(a) ? a.value = c : null),
        required: e.required,
        disabled: e.disabled
      }, null, 8, ze)), [
        [j, f(a)]
      ]) : L((s(), o("input", {
        key: 2,
        class: "cf-field__input",
        "onUpdate:modelValue": i[2] || (i[2] = (c) => q(a) ? a.value = c : null),
        type: e.type,
        placeholder: e.placeholder,
        list: e.list,
        required: e.required,
        disabled: e.disabled
      }, null, 8, Ae)), [
        [I, f(a)]
      ]),
      e.prefix && !["select", "textarea"].includes(e.type) ? (s(), o("div", Te, u(e.prefix), 1)) : v("", !0),
      e.suffix && !["select", "textarea"].includes(e.type) ? (s(), o("div", Fe, u(e.suffix), 1)) : v("", !0),
      e.label ? (s(), o("label", Me, u(e.label), 1)) : v("", !0),
      e.helper ? (s(), o("small", Ne, u(e.helper), 1)) : v("", !0),
      Ie
    ]));
  }
};
const Pe = { class: "cf-data-table-item" }, Ke = {
  key: 0,
  class: "cf-data-table-item__drawer"
}, Ue = { class: "cf-data-table-item__drawer__content" }, Oe = { class: "cf-data-table-item__content" }, Re = ["data-label"], Ee = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), je = [
  Ee
], Ze = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), Ge = {
  __name: "DataTableItem",
  props: {
    data: Object,
    expandable: Boolean
  },
  setup(n) {
    const t = n, e = T("columns", []), a = x(!1);
    return (d, i) => {
      const c = C("router-link");
      return s(), o("div", Pe, [
        a.value ? (s(), o("div", Ke, [
          l("div", Ue, [
            _(d.$slots, "default", {
              item: t.data
            })
          ])
        ])) : v("", !0),
        l("div", Oe, [
          (s(!0), o(S, null, V(f(e), (p) => (s(), o("div", {
            key: p.key,
            "data-label": p.label
          }, u(n.data[p.key]), 9, Re))), 128))
        ]),
        t.expandable ? (s(), o("button", {
          key: 1,
          class: "cf-data-table-item__toggle",
          onClick: i[0] || (i[0] = (p) => a.value = !a.value)
        }, je)) : v("", !0),
        t.data.to ? (s(), y(c, {
          key: 2,
          class: "cf-data-table-item__toggle",
          to: t.data.to
        }, {
          default: h(() => [
            Ze
          ]),
          _: 1
        }, 8, ["to"])) : v("", !0),
        t.expandable && a.value ? (s(), o("div", {
          key: 3,
          class: "cf-data-table-item__backdrop",
          onClick: i[1] || (i[1] = (p) => a.value = !1)
        })) : v("", !0)
      ]);
    };
  }
};
const He = { class: "cf-data-table" }, Xe = { class: "cf-data-table__header" }, Je = { class: "cf-data-table__header__content" }, Qe = {
  key: 0,
  class: "cf-data-table__title"
}, We = {
  key: 1,
  class: "cf-data-table__description"
}, Ye = {
  key: 2,
  class: "cf-data-table__search"
}, et = {
  key: 3,
  class: "cf-data-table__actions"
}, tt = {
  key: 0,
  class: "cf-data-table__header__slot"
}, st = { class: "cf-data-table__body__header" }, lt = { class: "cf-data-table__body__items" }, ot = {
  key: 0,
  class: "cf-data-table__footer"
}, at = { class: "cf-data-table__footer__pagination" }, nt = ["disabled"], it = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M11.022 14.503L4.518 8l6.504-6.504.707.707L5.932 8l5.797 5.796-.707.707z" })
], -1), dt = [
  it
], rt = ["disabled"], ut = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M4.99 14.503l-.707-.707L10.08 8 4.283 2.203l.707-.707L11.494 8 4.99 14.503z" })
], -1), ct = [
  ut
], _t = { key: 0 }, Ls = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    expandable: Boolean,
    paginate: {
      type: Boolean,
      default: !0
    },
    searchKey: String,
    pluralTerm: {
      type: String,
      default: "items"
    },
    itemKey: String,
    pageSize: {
      type: [Number, String],
      default: 10
    },
    columns: {
      type: Array,
      default: []
    },
    data: {
      type: Array,
      default: []
    }
  },
  setup(n) {
    const t = n, e = N(), a = x(""), d = m(() => t.data.filter((r) => {
      if (a.value) {
        const g = r[t.searchKey].replaceAll(" ", "").toLowerCase(), $ = a.value.replaceAll(" ", "").toLowerCase();
        return g.includes($);
      } else
        return !0;
    })), i = x(1), c = m(() => Math.ceil(d.value.length / parseInt(t.pageSize))), p = m(() => {
      const r = i.value < c.value ? i.value * t.pageSize : d.value.length;
      return {
        start: (i.value - 1) * t.pageSize + 1,
        end: r
      };
    }), k = m(() => t.paginate ? d.value.slice(
      (i.value - 1) * parseInt(t.pageSize),
      i.value * parseInt(t.pageSize)
    ) : d.value), D = () => {
      i.value < c.value && i.value++;
    }, b = () => {
      i.value > 1 && i.value--;
    };
    return Z(a, () => {
      i.value > 1 && (i.value = 1);
    }), F("columns", t.columns), (r, g) => (s(), o("div", He, [
      l("div", Xe, [
        l("div", Je, [
          t.title ? (s(), o("div", Qe, u(t.title), 1)) : v("", !0),
          t.description ? (s(), o("div", We, u(t.description), 1)) : v("", !0),
          t.searchKey ? (s(), o("div", Ye, [
            z(O, {
              modelValue: a.value,
              "onUpdate:modelValue": g[0] || (g[0] = ($) => a.value = $),
              type: "text",
              label: "Search"
            }, null, 8, ["modelValue"])
          ])) : v("", !0),
          f(e).actions ? (s(), o("div", et, [
            _(r.$slots, "actions")
          ])) : v("", !0)
        ]),
        f(e).header ? (s(), o("div", tt, [
          _(r.$slots, "header")
        ])) : v("", !0)
      ]),
      l("div", {
        class: "cf-data-table__body",
        style: G(`--columns: ${t.columns.length}`)
      }, [
        l("div", st, [
          (s(!0), o(S, null, V(t.columns, ($) => (s(), o("div", {
            key: $.key
          }, u($.label), 1))), 128))
        ]),
        l("div", lt, [
          (s(!0), o(S, null, V(f(k), ($) => (s(), y(Ge, {
            key: $._id || $[t.itemKey],
            data: $,
            expandable: t.expandable
          }, {
            default: h((M) => [
              _(r.$slots, "item-drawer", {
                item: M.item
              })
            ]),
            _: 2
          }, 1032, ["data", "expandable"]))), 128))
        ])
      ], 4),
      t.paginate ? (s(), o("div", ot, [
        l("div", at, [
          l("button", {
            disabled: i.value <= 1,
            onClick: b
          }, dt, 8, nt),
          l("button", {
            disabled: i.value >= f(c),
            onClick: D
          }, ct, 8, rt),
          f(d).length ? (s(), o("div", _t, [
            l("b", null, u(`${f(p).start} to ${f(p).end}`), 1),
            B(" of "),
            l("b", null, u(f(d).length), 1)
          ])) : v("", !0)
        ])
      ])) : v("", !0)
    ]));
  }
};
const pt = { class: "cf-sidebar-nav" }, ft = /* @__PURE__ */ l("hr", null, null, -1), vt = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), bt = /* @__PURE__ */ l("span", null, "Collapse sidebar", -1), mt = [
  vt,
  bt
], ht = {
  __name: "Sidebar",
  setup(n) {
    const t = x(!1), e = m(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (a, d) => (s(), o("aside", {
      class: w(f(e))
    }, [
      l("nav", pt, [
        _(a.$slots, "default"),
        ft
      ]),
      l("button", {
        class: "cf-sidebar-toggle",
        onClick: d[0] || (d[0] = (i) => t.value = !t.value)
      }, mt)
    ], 2));
  }
};
const zs = {
  __name: "DefaultLayout",
  setup(n) {
    return P(() => {
      document.body.dataset.layout = "default";
    }), (t, e) => (s(), o(S, null, [
      z(oe, null, {
        left: h(() => [
          _(t.$slots, "brand")
        ]),
        right: h(() => [
          _(t.$slots, "navigation")
        ]),
        _: 3
      }),
      z(ht, null, {
        default: h(() => [
          _(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      l("main", null, [
        _(t.$slots, "main")
      ])
    ], 64));
  }
};
const gt = { class: "cf-dialog-header" }, yt = { class: "cf-dialog__title" }, $t = { key: 0 }, kt = { class: "cf-dialog-body" }, wt = { class: "cf-dialog-footer" }, xt = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), St = [
  xt
], As = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(n, { emit: t }) {
    const e = n, a = x(null);
    return P(() => {
      a.value.showModal(), a.value.addEventListener("close", () => {
        t("close");
      });
    }), (d, i) => (s(), o("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: a
    }, [
      l("div", gt, [
        l("div", yt, u(e.title), 1),
        e.description ? (s(), o("div", $t, u(e.description), 1)) : v("", !0)
      ]),
      l("div", kt, [
        _(d.$slots, "body")
      ]),
      l("div", wt, [
        _(d.$slots, "footer")
      ]),
      l("button", {
        class: "cf-dialog-close",
        onClick: i[0] || (i[0] = (c) => t("close"))
      }, St)
    ], 512));
  }
};
const Vt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Bt = { class: "material-symbols-outlined" }, Ct = { class: "cf-dropdown-item__label" }, qt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Dt = { class: "material-symbols-outlined" }, Lt = { class: "cf-dropdown-item__label" }, Ts = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(n) {
    const t = n, e = m(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (a, d) => {
      const i = C("router-link");
      return n.to ? (s(), y(i, {
        key: 1,
        class: w(f(e)),
        to: n.to
      }, {
        default: h(() => [
          n.icon ? (s(), o("div", qt, [
            l("span", Dt, u(n.icon), 1)
          ])) : v("", !0),
          l("div", Lt, [
            _(a.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (s(), o("button", {
        key: 0,
        class: w(f(e))
      }, [
        n.icon ? (s(), o("div", Vt, [
          l("span", Bt, u(n.icon), 1)
        ])) : v("", !0),
        l("div", Ct, [
          _(a.$slots, "default")
        ])
      ], 2));
    };
  }
};
const zt = { class: "cf-drop-zone" }, At = ["onDrop"], Tt = { class: "cf-drop-zone-box__label" }, Ft = { class: "cf-drop-zone-box__action" }, Mt = /* @__PURE__ */ l("span", null, "select from device", -1), Nt = ["required"], It = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Pt = {
  key: 1,
  class: "cf-drop-zone-list"
}, Kt = /* @__PURE__ */ l("div", { class: "cf-drop-zone-list__header" }, null, -1), Ut = { class: "cf-drop-zone-list__item" }, Ot = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Rt = [
  Ot
], Fs = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: Boolean
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(n, { emit: t }) {
    const e = n, a = x(null), d = m(() => !!(e.required && !e.modelValue)), i = m(() => {
      if (e.modelValue) {
        const r = (e.modelValue.size / 1048576).toFixed(0), g = (r / 1e3).toFixed(1);
        return r < 100 ? `${r} MB` : `${g} GB`;
      } else
        return "0 MB";
    }), c = (b) => {
      const r = b.target.files[0];
      k(r);
    }, p = (b) => {
      const r = b.dataTransfer.files[0];
      k(r);
    }, k = (b) => {
      const r = parseInt(e.max) * 1048576;
      r && r < b.size ? (a.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", b), t("add", b));
    }, D = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (b, r) => (s(), o("div", zt, [
      n.modelValue ? (s(), o("div", Pt, [
        Kt,
        l("div", Ut, [
          l("div", null, u(e.modelValue.name), 1),
          l("div", null, u(f(i)), 1),
          l("button", { onClick: D }, Rt)
        ])
      ])) : (s(), o("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: A(p, ["prevent"]),
        onDragenter: r[0] || (r[0] = A(() => {
        }, ["prevent"])),
        onDragover: r[1] || (r[1] = A(() => {
        }, ["prevent"])),
        onDragleave: r[2] || (r[2] = A(() => {
        }, ["prevent"]))
      }, [
        l("div", Tt, u(e.label), 1),
        l("label", Ft, [
          B(" Drag and drop or "),
          Mt,
          l("input", {
            type: "file",
            ref_key: "input",
            ref: a,
            required: f(d),
            onChange: c
          }, null, 40, Nt)
        ]),
        e.max ? (s(), o("div", It, " Files larger than " + u(e.max) + " MB cannot be uploaded ", 1)) : v("", !0)
      ], 40, At))
    ]));
  }
};
const Et = { class: "cf-tag" }, jt = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Zt = [
  jt
], R = {
  __name: "Tag",
  props: {
    removable: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["remove"],
  setup(n, { emit: t }) {
    const e = n;
    return (a, d) => (s(), o("div", Et, [
      l("span", null, [
        _(a.$slots, "default")
      ]),
      e.removable ? (s(), o("button", {
        key: 0,
        onClick: d[0] || (d[0] = (i) => t("remove"))
      }, Zt)) : v("", !0)
    ]));
  }
};
const Gt = { class: "cf-file-picker" }, Ht = {
  key: 0,
  class: "cf-file-picker-label"
}, Xt = {
  key: 1,
  class: "cf-button cf-file-picker-button"
}, Jt = ["required"], Ms = {
  __name: "FilePicker",
  props: {
    modelValue: File,
    label: String,
    action: {
      type: String,
      default: "Choose file"
    },
    required: Boolean
  },
  emits: ["update:modelValue", "change"],
  setup(n, { emit: t }) {
    const e = n, a = (i) => {
      t("update:modelValue", i.target.files[0]), t("change", i);
    }, d = () => {
      t("update:modelValue", null);
    };
    return (i, c) => (s(), o("div", Gt, [
      e.label ? (s(), o("div", Ht, u(e.label), 1)) : v("", !0),
      e.modelValue ? (s(), y(R, {
        key: 2,
        onRemove: d
      }, {
        default: h(() => {
          var p;
          return [
            B(u((p = e.modelValue) == null ? void 0 : p.name), 1)
          ];
        }),
        _: 1
      })) : (s(), o("label", Xt, [
        B(u(e.action) + " ", 1),
        l("input", {
          type: "file",
          onChange: a,
          required: n.required
        }, null, 40, Jt)
      ]))
    ]));
  }
};
const Qt = ["value", "max"], Ns = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(n) {
    const t = n;
    return (e, a) => (s(), o("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, u(n.value) + "% ", 9, Qt));
  }
};
const Wt = { class: "cf-sidebar-link__icon" }, Yt = { class: "material-symbols-outlined" }, es = { class: "cf-sidebar-link__label" }, ts = ["href"], ss = { class: "cf-sidebar-link__icon" }, ls = { class: "material-symbols-outlined" }, os = { class: "cf-sidebar-link__label" }, Is = {
  __name: "SidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(n) {
    const t = n;
    return (e, a) => {
      const d = C("router-link");
      return n.to ? (s(), y(d, {
        key: 0,
        class: "cf-sidebar-link",
        to: t.to
      }, {
        default: h(() => [
          l("div", Wt, [
            l("span", Yt, u(n.icon), 1)
          ]),
          l("div", es, [
            _(e.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (s(), o("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: n.href
      }, [
        l("div", ss, [
          l("span", ls, u(n.icon), 1)
        ]),
        l("div", os, [
          _(e.$slots, "default")
        ])
      ], 8, ts));
    };
  }
};
const as = {}, ns = { class: "cf-spinner" }, is = /* @__PURE__ */ l("div", null, null, -1), ds = /* @__PURE__ */ l("div", null, null, -1), rs = /* @__PURE__ */ l("div", null, null, -1), us = /* @__PURE__ */ l("div", null, null, -1), cs = [
  is,
  ds,
  rs,
  us
];
function _s(n, t) {
  return s(), o("div", ns, cs);
}
const Ps = /* @__PURE__ */ K(as, [["render", _s]]);
const ps = { class: "cf-switch" }, fs = ["value", "true-value", "false-value", "disabled"], vs = {
  key: 0,
  class: "cf-switch__label"
}, Ks = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = m({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return (d, i) => (s(), o("div", ps, [
      L(l("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": i[0] || (i[0] = (c) => q(a) ? a.value = c : null),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, fs), [
        [H, f(a)]
      ]),
      e.label ? (s(), o("div", vs, u(e.label), 1)) : v("", !0)
    ]));
  }
};
const bs = { class: "cf-navigation-tabs" }, Us = {
  __name: "TabNavigation",
  props: {
    tabs: Array
  },
  setup(n) {
    const t = n;
    return (e, a) => {
      const d = C("router-link");
      return s(), o("nav", bs, [
        l("ul", null, [
          (s(!0), o(S, null, V(t.tabs, (i, c) => (s(), o("li", { key: c }, [
            z(d, {
              to: i.to
            }, {
              default: h(() => [
                B(u(i.label), 1)
              ]),
              _: 2
            }, 1032, ["to"])
          ]))), 128))
        ])
      ]);
    };
  }
};
const ms = ["inert"], hs = { key: 0 }, gs = { class: "cf-tags-field__input" }, ys = ["required"], $s = { class: "cf-tags-field__tags" }, ks = { key: 1 }, Os = {
  __name: "TagsField",
  props: {
    modelValue: Array,
    label: String,
    buttonText: {
      type: String,
      default: "Add"
    },
    prefix: String,
    options: Array,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = x(!1), d = x(""), i = m(() => {
      var b;
      return (b = e.options) == null ? void 0 : b.map((r) => ({
        label: r.label || r,
        value: r.value || r
      }));
    }), c = m(() => {
      var b;
      return (b = i.value) == null ? void 0 : b.filter(
        (r) => !e.modelValue.includes(r.value)
      );
    }), p = (b) => i.value.find((r) => r.value === b).label, k = () => {
      if (!d.value || e.disabled)
        return !1;
      const b = e.modelValue;
      b.push(d.value), t("update:modelValue", b), d.value = "", a.value = !1;
    }, D = (b) => {
      if (e.disabled)
        return !1;
      const r = e.modelValue;
      r.splice(b, 1), t("update:modelValue", r);
    };
    return (b, r) => (s(), o("div", {
      class: "cf-tags-field",
      inert: e.disabled
    }, [
      e.label ? (s(), o("label", hs, u(e.label), 1)) : v("", !0),
      l("div", gs, [
        a.value ? (s(), y(O, {
          key: 0,
          modelValue: d.value,
          "onUpdate:modelValue": r[0] || (r[0] = (g) => d.value = g),
          type: e.options ? "select" : "text",
          prefix: e.prefix,
          options: f(c),
          onKeydown: X(k, ["enter"]),
          onChange: k,
          required: ""
        }, null, 8, ["modelValue", "type", "prefix", "options", "onKeydown"])) : (s(), y(ye, {
          key: 1,
          color: "blue",
          onClick: r[1] || (r[1] = (g) => a.value = !0)
        }, {
          default: h(() => [
            B(u(e.buttonText), 1)
          ]),
          _: 1
        })),
        l("input", {
          class: "cf-tags-field__input__faux",
          type: "text",
          required: e.required && !e.modelValue.length
        }, null, 8, ys)
      ]),
      l("div", $s, [
        (s(!0), o(S, null, V(e.modelValue, (g, $) => (s(), y(R, {
          key: g,
          onRemove: (M) => D($)
        }, {
          default: h(() => [
            B(u(e.prefix) + " " + u(e.options ? p(g) : g), 1)
          ]),
          _: 2
        }, 1032, ["onRemove"]))), 128))
      ]),
      e.helper ? (s(), o("small", ks, u(e.helper), 1)) : v("", !0)
    ], 8, ms));
  }
};
export {
  xs as CfActionCard,
  oe as CfAppBar,
  Ss as CfAppBarLink,
  Vs as CfAppView,
  Bs as CfBanner,
  Ve as CfChoice,
  Ds as CfChoiceList,
  Ls as CfDataTable,
  zs as CfDefaultLayout,
  As as CfDialog,
  Fs as CfDropZone,
  ne as CfDropdown,
  Ts as CfDropdownItem,
  O as CfField,
  Ms as CfFilePicker,
  Cs as CfFilledButton,
  ye as CfOutlinedButton,
  Ns as CfProgress,
  ht as CfSidebar,
  Is as CfSidebarLink,
  Ps as CfSpinner,
  Ks as CfSwitch,
  Us as CfTabNavigation,
  R as CfTag,
  Os as CfTagsField,
  qs as CfTextButton
};
